﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DockManager;
using Infragistics.Windows.DockManager.Events;

namespace XamDocLayoutsaving
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ButtonAddOnClick(object sender, RoutedEventArgs e)
        {
            var panesNumber = AppDockManager.GetPanes(PaneNavigationOrder.ActivationOrder).Count() + 1;
            var id = Guid.NewGuid().ToString();
            var tag = "Pane :" + panesNumber + Environment.NewLine + id;
            var newPane = new ContentPane()
            {
                Name = "Pane" + id.Replace("-", ""),
                Header = "Pane " + panesNumber ,
                SerializationId = id,
                IsEnabled = true,
                Tag = tag,
                Visibility = Visibility.Visible,
                Content = new ContentUserControl(tag)
            };
            this.MainTabGroupPane.Items.Add(newPane);
            newPane.Activate();
        }

        private void ButtonSaveOnClick(object sender, RoutedEventArgs e)
        {
            using (var fs = new FileStream(@"D:\Temp\layout.xml", FileMode.Create, FileAccess.Write))
            {
                this.AppDockManager.SaveLayout(fs);
            }
        }

        private void ButtonLoadOnClick(object sender, RoutedEventArgs e)
        {
            string filePath = @"D:\Temp\layout.xml";
            if (!File.Exists(filePath)) return;

            using (var fs = new FileStream(filePath, FileMode.Open, FileAccess.Read))
            {
                this.AppDockManager.LoadLayout(fs);
            }
            MainTabGroupPane.SelectedIndex = 0;
            HardcodedPane.Activate();
        }

        // Handle the InitializePaneContent event to add content to missing panes
        private void DockManagerOnInitializePaneContent(object sender,InitializePaneContentEventArgs e)
        {
            var panesNumber = AppDockManager.GetPanes(PaneNavigationOrder.ActivationOrder).Count() + 1;
            var tag = "Pane :" + panesNumber + Environment.NewLine + e.NewPane.SerializationId;
            //reconstruct the tab
            var newPane = new ContentPane()
            {
                Name = "Pane" + e.NewPane.SerializationId.Replace("-", ""),
                Header = "Pane " + panesNumber,
                SerializationId = e.NewPane.SerializationId,
                IsEnabled = true,
                Tag = tag,
                Visibility = Visibility.Visible,
                Content = new ContentUserControl(tag)
            };
            
            this.MainTabGroupPane.Items.Add(newPane);
        }
    }
}
